// (c) Copyright 2013 Cloudera, Inc. All rights reserved.
define([
  "cloudera/Util"
], function(Util) {

  return function(options) {
    var self = this;
    var $container = $(options.containerSelector);
    var $collapseAllLink = $container.find(".collapseAllLink");
    var $expandAllLink = $container.find(".expandAllLink");

    var collapseAll = function(e) {
      $container.find(".statusBody").addClass("hidden");
      $container.find(".toggleIcon")
        .removeClass("icon-chevron-down")
        .addClass("icon-chevron-right");
      $.publish("statusCollapseStateChanged");
      e.preventDefault();
    };

    var expandAll = function(e) {
      $container.find(".statusBody").removeClass("hidden");
      $container.find(".toggleIcon")
        .removeClass("icon-chevron-right")
        .addClass("icon-chevron-down");
      $.publish("statusCollapseStateChanged");
      e.preventDefault();
    };

    var updateExpandCollapseLinks = function() {
      if ($container.find(".statusBody:not(.hidden)").length > 0) {
        $collapseAllLink.removeClass("hidden");
        $expandAllLink.addClass("hidden");
      } else {
        $collapseAllLink.addClass("hidden");
        $expandAllLink.removeClass("hidden");
      }
    };

    $collapseAllLink.click(collapseAll);
    $expandAllLink.click(expandAll);

    var handle = $.subscribe("statusCollapseStateChanged", updateExpandCollapseLinks);
    self.subscriptionHandles = [handle];
    self.unsubscribe = function() {
      Util.unsubscribe(self);
    };
  };
});
