// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/Monitor","cloudera/cmf/charts/Plot","cloudera/cmf/charts/TimeSeriesVisualizer","underscore"],function(e,t,n,r,i){describe("TimeSeriesVisualizer Tests",function(){function c(e){spyOn(e,"createVisualizer").andReturn(a),spyOn(a,"renderPlaceholder"),e.render(f)}var s,o="tcVisualizerContainer",u={plot:{tsquery:"Some Query",title:"My Chart Title",chartType:n.ChartType.LINE},container:"#"+o,enableFacets:!0},a={isRendered:function(){return!1},render:function(){},renderPlaceholder:function(){}},f={timeSeries:[{data:[{x:1,y:2}],metadata:{attributes:{}}},{data:[{x:2,y:3}],metadata:{attributes:{}}},{data:[],metadata:{}},{}]},l=new t("TimeSeriesVisualizer.render");beforeEach(function(){$('<div id="'+o+'"></div>').appendTo(document.body)}),afterEach(function(){s.unsubscribe(),$("#"+o).remove()}),it("should create a TimeSeriesVisualizer object",function(){s=new r(u),expect(s.facets).toBeDefined(),expect(s.getViewModel()).toBeDefined()}),it("should test the TimeSeriesVisualizer.render method",function(){s=new r(u),spyOn(s.facets,"update"),spyOn(s,"createVisualizer").andReturn(a),spyOn(a,"renderPlaceholder"),s.render(f),expect($("#"+o).find(".yAxis").length).toEqual(2),expect($("#"+o).find(".chart").length).toEqual(2),expect($("#"+o).find(".chart-container").length).toEqual(2),expect($("#"+o).find(".chart-title").length).toEqual(3),expect(a.renderPlaceholder).wasCalled(),expect(s.vizs.length).toEqual(2),expect(s.facets.update).wasCalled()}),it("should test the TimeSeriesVisualizer.render method without yAxis",function(){var e=$.extend(!0,{},u);e.plot.showYAxis=!1,s=new r(e),spyOn(s.facets,"update"),spyOn(s,"createVisualizer").andReturn(a),spyOn(a,"renderPlaceholder"),s.render(f),expect($("#"+o).find(".yAxis").length).toEqual(0),expect($("#"+o).find(".chart").length).toEqual(2),expect($("#"+o).find(".chart-container").length).toEqual(2),expect($("#"+o).find(".chart-title").length).toEqual(3),expect(a.renderPlaceholder).wasCalled(),expect(s.vizs.length).toEqual(2),expect(s.facets.update).wasCalled()}),it("should test the TimeSeriesVisualizer.regroupTimeSeries method",function(){s=new r(u);var e=[{data:[{x:1,y:2}],metadata:{attributes:{a:"a0",b:"b1"}}},{data:[{x:2,y:3}],metadata:{attributes:{a:"a0",b:"b0"}}},{data:[{x:3,y:4}],metadata:{attributes:{a:"a0",b:"b0"}}}],t=s.regroupTimeSeries(e,n.FACETTING_SINGLE_PLOT);expect(t[0].value).toEqual(e),t=s.regroupTimeSeries(e,"a"),expect(t[0].value.length).toEqual(3),t=s.regroupTimeSeries(e,"b"),expect(t[0].value.length).toEqual(2),expect(t[1].value.length).toEqual(1),t=s.regroupTimeSeries(e,"a,b"),expect(t[0].value.length).toEqual(2),expect(t[1].value.length).toEqual(1),t=s.regroupTimeSeries(e,n.FACETTING_NONE),expect(t[0].value[0]).toEqual(e[0]),expect(t[1].value[0]).toEqual(e[1]),expect(t[2].value[0]).toEqual(e[2])}),it("should catch the clickFacetGroup event",function(){s=new r(u),spyOn(s,"render"),$.publish("clickFacetGroup",[n.FACETTING_NONE]),expect(s.render).wasCalled()}),it("should ensure enlargeable class is added",function(){s=new r(u),c(s);var e=$("#"+o).find(".chart-container");expect(e.hasClass("enlargeable")).toBeTruthy()}),it("should ensure enlargeable class is not added",function(){var e=$.extend({},u,{enableEnlarging:!1});s=new r(e),c(s);var t=$("#"+o).find(".chart-container");expect(t.hasClass("enlargeable")).toBeFalsy()}),it("should test the various actions",function(){var e=$.extend(!0,{enableEditing:!0,enableCloning:!0,enableRemoving:!0},u);s=new r(e),c(s),spyOn($,"publish");var t=$("#"+o);t.find(".edit-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("editPlot"),t.find(".clone-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("clonePlot"),t.find(".remove-chart").trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("removePlot")}),it("should test setDimension",function(){s=new r(u),spyOn(s,"adjustTitleWidth"),spyOn(s,"setChartDimension"),s.setDimension(200,300),expect(s.adjustTitleWidth.mostRecentCall.args[1]).toBeDefined(),expect(s.setChartDimension.mostRecentCall.args[1]).toBeDefined()}),it("should render a legend conditional on the number of streams",function(){var e=function(){return{data:[{x:1,y:2}],metadata:{attributes:{}}}},t=i.defaults({plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,showLegend:!0,facetting:n.FACETTING_SINGLE_PLOT}},u);s=new r(t);var o={timeSeries:i.map(i.range(50),e)};spyOn(s,"addLegendContainer"),spyOn(s,"createVisualizer").andCallThrough(),s.render(o),expect(s.addLegendContainer).wasCalled(),s.addLegendContainer.reset();var a=s.createVisualizer.mostRecentCall.args;expect(a[0].showLegend).toBeTruthy(),o.timeSeries.push(e()),s.render(o),expect(s.addLegendContainer).wasNotCalled(),a=s.createVisualizer.mostRecentCall.args,expect(a[0].showLegend).toBeFalsy()}),it("should test setFilter",function(){s=new r(u),spyOn(s,"deferRenderVisibleCharts"),s.render(f),s.setFilter("Hello World"),expect(s.$chartsContainer.find(".chart-container:visible").length).toEqual(0),s.setFilter("Chart"),expect(s.$chartsContainer.find(".chart-container:visible").length).toEqual(2),expect(s.deferRenderVisibleCharts).wasCalled(),spyOn(s,"setFilter"),s.render(f),expect(s.setFilter).wasCalledWith("Chart")}),it("should test matchesFilter",function(){s=new r(u),s.timeSeriesResponse={timeSeries:["dontcare"]},spyOn(s,"render"),s.setFilter("Hello Cloudera"),expect(s.matchesFilter("Hello Cloudera Manager")).toBeTruthy(),expect(s.matchesFilter("Cloudera Manager Hello")).toBeTruthy(),expect(s.matchesFilter("Hello Manager")).toBeFalsy()}),it("should make sure matched charts are rendered",function(){var e=$.extend({},u,{plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,title:"My Plot Title"}});spyOn($.fn,"hide").andCallThrough(),s=new r(e),c(s),s.setFilter("Plot Title"),expect(s.createVisualizer.callCount).toEqual(2),expect($.fn.hide).wasNotCalled()}),it("should make sure unmatched charts are not rendered",function(){var e=$.extend({},u,{plot:{tsquery:"Some Query",chartType:n.ChartType.LINE,title:"My Plot Title"}});spyOn($.fn,"hide").andCallThrough(),s=new r(e),c(s),s.setFilter("Blah Blah"),expect(s.createVisualizer.callCount).toEqual(2),expect($.fn.hide).wasCalled()}),it("should not call enableProgressiveLoading if enableLoadAll is true",function(){var e=$.extend({},u,{enableLoadAll:!0});spyOn(r.prototype,"enableProgressiveLoading").andCallThrough(),s=new r(e),expect(r.prototype.enableProgressiveLoading).wasNotCalled()}),it("should call enableProgressiveLoading if enableLoadAll is undefined or false",function(){var e=$.extend({},u,{enableLoadAll:!1});spyOn(r.prototype,"enableProgressiveLoading").andCallThrough(),s=new r(e),expect(r.prototype.enableProgressiveLoading).wasCalled()}),it("should call render if enableLoadAll is true",function(){var e=$.extend({},u,{enableLoadAll:!0});s=new r(e),spyOn(s,"createVisualizer").andReturn(a),spyOn(a,"render"),spyOn(a,"renderPlaceholder"),s.render(f),expect(a.render).wasCalled(),expect(a.renderPlaceholder).wasNotCalled()}),it("should call renderPlaceholder if enableLoadAll is false",function(){var e=$.extend({},u,{enableLoadAll:!1});s=new r(e),spyOn(s,"createVisualizer").andReturn(a),spyOn(a,"render"),spyOn(a,"renderPlaceholder"),s.render(f),expect(a.render).wasNotCalled(),expect(a.renderPlaceholder).wasCalled()}),it("should test shouldRender and result in false",function(){s=new r(u),expect(s.shouldRender(50,100,200,800)).toBeFalsy(),expect(s.shouldRender(50,100,10,20)).toBeFalsy()}),it("should test shouldRender and result in true",function(){s=new r(u),expect(s.shouldRender(20,100,20,100)).toBeTruthy(),expect(s.shouldRender(20,100,20,30)).toBeTruthy(),expect(s.shouldRender(20,100,10,30)).toBeTruthy(),expect(s.shouldRender(20,100,30,80)).toBeTruthy(),expect(s.shouldRender(20,100,80,120)).toBeTruthy(),expect(s.shouldRender(20,100,80,100)).toBeTruthy(),expect(s.shouldRender(50,100,20,200)).toBeTruthy()}),it("should test deferRenderVisibleCharts",function(){s=new r(u),e.setTestMode(!1),spyOn(i,"defer"),s.deferRenderVisibleCharts(),expect(i.defer).wasCalled(),e.setTestMode(!0)}),it("should test renderVisibleChartWithinRange",function(){s=new r(u),spyOn(s,"createVisualizer").andReturn(a),spyOn(a,"render"),s.render(f);var e=$("#"+o).find(".chart-container:first");spyOn(e,"offset").andReturn({top:50,left:0}),spyOn(e,"height").andReturn(30),s.renderVisibleChartWithinRange(e,0,100),expect(a.render).wasCalled(),expect(a.render.callCount).toEqual(1),s.renderVisibleChartWithinRange(e,100,200),expect(a.render.callCount).toEqual(1)}),it("should test renderVisibleCharts",function(){s=new r(u),s.render(f),spyOn(s,"renderVisibleChartWithinRange"),spyOn(s,"renderInvisibleChartsWithPlaceholder"),s.renderVisibleCharts($(window)),expect(s.renderVisibleChartWithinRange).wasCalled(),s.$chartsContainer.find(".chart-container").hide(),s.renderVisibleCharts($(window)),expect(s.renderInvisibleChartsWithPlaceholder).wasCalled()}),it("should test showPlotDetails",function(){s=new r(u),s.render(f),spyOn($,"publish");var e=$("#"+o).find(".chart-container:first");e.trigger("click"),expect($.publish).wasCalled(),expect($.publish.mostRecentCall.args[0]).toEqual("showPlotDetails"),expect($.publish.mostRecentCall.args[1][2]).toEqual("My Chart Title")}),it("should test calculateDynamicRange",function(){s=new r(u),s.viewModel.facetting("metric");var e={timeSeries:[{data:[{x:1,y:2},{x:2,y:4}],metadata:{metric:"Metric 1",attributes:{}}},{data:[{x:2,y:3},{x:3,y:5}],metadata:{metric:"Metric 1",attributes:{}}},{data:[{x:3,y:4},{x:4,y:10}],metadata:{metric:"Metric 2",attributes:{}}}]},t=s.getGroupedTimeSeries(e,l);s.calculateDynamicRange(t,l),expect(t[0].ymin).toEqual(2),expect(t[0].ymax).toEqual(5),expect(t[1].ymin).toEqual(4),expect(t[1].ymax).toEqual(10)})})})